"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var RequestService_1 = require("./RequestService");
var api_1 = require("./api/");
var LibrariesIO = /** @class */ (function () {
    function LibrariesIO(options) {
        if (typeof options === 'string') {
            options = { apiKey: options };
        }
        this.options = options;
        if (!this.options.apiKey) {
            throw new Error('An API key needs to be set in order to use the client.');
        }
        this.requestService = new RequestService_1.RequestService(options);
        this.api = {
            github: {
                repository: new api_1.GitHubRepositoryAPI(this.requestService),
                user: new api_1.GitHubUserAPI(this.requestService),
            },
            platform: new api_1.PlatformAPI(this.requestService),
            project: new api_1.ProjectAPI(this.requestService),
            user: new api_1.UserAPI(this.requestService),
        };
    }
    /**
     * Set a new API URL.
     * @param newUrl The new API url
     */
    LibrariesIO.prototype.setApiUrl = function (newUrl) {
        this.requestService.setApiUrl(newUrl);
    };
    return LibrariesIO;
}());
exports.LibrariesIO = LibrariesIO;
//# sourceMappingURL=APIClient.js.map