"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var APIException = /** @class */ (function (_super) {
    __extends(APIException, _super);
    function APIException(message, serverMessage) {
        var _newTarget = this.constructor;
        if (message === void 0) { message = ''; }
        var _this = _super.call(this, message) || this;
        _this.message += serverMessage ? ". (\"" + serverMessage + "\")" : '. The server did not provide any further information.';
        Object.setPrototypeOf(_this, _newTarget.prototype);
        return _this;
    }
    return APIException;
}(Error));
exports.APIException = APIException;
var AuthenticationError = /** @class */ (function (_super) {
    __extends(AuthenticationError, _super);
    function AuthenticationError(message, serverMessage) {
        var _newTarget = this.constructor;
        if (message === void 0) { message = ''; }
        var _this = _super.call(this, message) || this;
        _this.message += '. Wrong API key?' + (serverMessage ? " (\"" + serverMessage + "\")" : '');
        Object.setPrototypeOf(_this, _newTarget.prototype);
        return _this;
    }
    return AuthenticationError;
}(Error));
exports.AuthenticationError = AuthenticationError;
var RateLimitError = /** @class */ (function (_super) {
    __extends(RateLimitError, _super);
    function RateLimitError(message, serverMessage) {
        var _newTarget = this.constructor;
        if (message === void 0) { message = ''; }
        var _this = _super.call(this, message) || this;
        _this.message += ': Rate limit hit.' + (serverMessage ? " (\"" + serverMessage + "\")" : '');
        Object.setPrototypeOf(_this, _newTarget.prototype);
        return _this;
    }
    return RateLimitError;
}(Error));
exports.RateLimitError = RateLimitError;
var NotFoundError = /** @class */ (function (_super) {
    __extends(NotFoundError, _super);
    function NotFoundError(message, serverMessage) {
        var _newTarget = this.constructor;
        if (message === void 0) { message = ''; }
        var _this = _super.call(this, message) || this;
        _this.message += serverMessage ? ": \"" + serverMessage + "\"." : '. The server did not provide any further information.';
        Object.setPrototypeOf(_this, _newTarget.prototype);
        return _this;
    }
    return NotFoundError;
}(Error));
exports.NotFoundError = NotFoundError;
var InvalidResponseError = /** @class */ (function (_super) {
    __extends(InvalidResponseError, _super);
    function InvalidResponseError(message) {
        var _newTarget = this.constructor;
        if (message === void 0) { message = ''; }
        var _this = _super.call(this, message) || this;
        Object.setPrototypeOf(_this, _newTarget.prototype);
        return _this;
    }
    return InvalidResponseError;
}(Error));
exports.InvalidResponseError = InvalidResponseError;
function ExceptionMapper(error) {
    if (error.response && error.response.status) {
        var serverMessage = error.response.data ? error.response.data.message : undefined;
        switch (error.response.status) {
            case 403:
                return new AuthenticationError(error.message, serverMessage);
            case 404:
                return new NotFoundError(error.message, serverMessage);
            case 429:
                return new RateLimitError(error.message, serverMessage);
            default:
                return new APIException(error.message, serverMessage);
        }
    }
    if (error instanceof InvalidResponseError) {
        return error;
    }
    return new Error(error.message);
}
exports.ExceptionMapper = ExceptionMapper;
//# sourceMappingURL=APIException.js.map