"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Endpoint;
(function (Endpoint) {
    var CONTRIBUTORS = 'contributors';
    var DEPENDENCIES = 'dependencies';
    var DEPENDENT_REPOSITORIES = 'dependent_repositories';
    var DEPENDENTS = 'dependents';
    var GITHUB = 'github';
    var PLATFORMS = 'platforms';
    var PROJECT_CONTRIBUTIONS = 'project-contributions';
    var PROJECTS = 'projects';
    var REPOSITORIES = 'repositories';
    var REPOSITORY_CONTRIBUTIONS = 'repository-contributions';
    var SEARCH = 'search';
    var SOURCERANK = 'sourcerank';
    var SUBSCRIPTIONS = 'subscriptions';
    var USAGE = 'usage';
    var encode = encodeURIComponent;
    var Project;
    (function (Project) {
        function contributors(platform, name) {
            return "/" + encode(platform) + "/" + encode(name) + "/" + CONTRIBUTORS + "/";
        }
        Project.contributors = contributors;
        function dependencies(platform, name, version) {
            return "/" + encode(platform) + "/" + encode(name) + "/" + encode(version) + "/" + DEPENDENCIES + "/";
        }
        Project.dependencies = dependencies;
        function dependentRepositories(platform, name) {
            return "/" + encode(platform) + "/" + encode(name) + "/" + DEPENDENT_REPOSITORIES + "/";
        }
        Project.dependentRepositories = dependentRepositories;
        function dependents(platform, name) {
            return "/" + encode(platform) + "/" + encode(name) + "/" + DEPENDENTS + "/";
        }
        Project.dependents = dependents;
        function search() {
            return "/" + SEARCH + "/";
        }
        Project.search = search;
        function sourceRank(platform, name) {
            return "/" + encode(platform) + "/" + encode(name) + "/" + SOURCERANK + "/";
        }
        Project.sourceRank = sourceRank;
        function subscriptions(platform, name) {
            return "/" + SUBSCRIPTIONS + "/" + encode(platform) + "/" + encode(name) + "/";
        }
        Project.subscriptions = subscriptions;
        function usage(platform, name) {
            return "/" + encode(platform) + "/" + encode(name) + "/" + USAGE + "/";
        }
        Project.usage = usage;
        function project(platform, name) {
            return "/" + encode(platform) + "/" + encode(name) + "/";
        }
        Project.project = project;
    })(Project = Endpoint.Project || (Endpoint.Project = {}));
    var GitHub;
    (function (GitHub) {
        var Repository;
        (function (Repository) {
            function dependencies(owner, name) {
                return "/" + GITHUB + "/" + encode(owner) + "/" + encode(name) + "/" + DEPENDENCIES + "/";
            }
            Repository.dependencies = dependencies;
            function projects(owner, name) {
                return "/" + GITHUB + "/" + encode(owner) + "/" + encode(name) + "/" + PROJECTS + "/";
            }
            Repository.projects = projects;
            function repository(owner, name) {
                return "/" + GITHUB + "/" + encode(owner) + "/" + encode(name) + "/";
            }
            Repository.repository = repository;
        })(Repository = GitHub.Repository || (GitHub.Repository = {}));
        var User;
        (function (User) {
            function dependencies(login) {
                return "/" + GITHUB + "/" + encode(login) + "/" + DEPENDENCIES + "/";
            }
            User.dependencies = dependencies;
            function packages(login) {
                return "/" + GITHUB + "/" + encode(login) + "/" + PROJECTS + "/";
            }
            User.packages = packages;
            function projects(login) {
                return "/" + GITHUB + "/" + encode(login) + "/" + PROJECTS + "/";
            }
            User.projects = projects;
            function contributedProjects(login) {
                return "/" + GITHUB + "/" + encode(login) + "/" + PROJECT_CONTRIBUTIONS + "/";
            }
            User.contributedProjects = contributedProjects;
            function repositories(login) {
                return "/" + GITHUB + "/" + encode(login) + "/" + REPOSITORIES + "/";
            }
            User.repositories = repositories;
            function contributedRepositories(login) {
                return "/" + GITHUB + "/" + encode(login) + "/" + REPOSITORY_CONTRIBUTIONS + "/";
            }
            User.contributedRepositories = contributedRepositories;
            function user(login) {
                return "/" + GITHUB + "/" + encode(login) + "/";
            }
            User.user = user;
        })(User = GitHub.User || (GitHub.User = {}));
    })(GitHub = Endpoint.GitHub || (Endpoint.GitHub = {}));
    function platforms() {
        return "/" + PLATFORMS + "/";
    }
    Endpoint.platforms = platforms;
    function subscriptions(platform, name) {
        var endpoint = "/" + SUBSCRIPTIONS + "/";
        if (platform && name) {
            endpoint += encode(platform) + "/" + encode(name) + "/";
        }
        return endpoint;
    }
    Endpoint.subscriptions = subscriptions;
})(Endpoint = exports.Endpoint || (exports.Endpoint = {}));
//# sourceMappingURL=Endpoints.js.map