/// <reference types="node" />
import { URL } from 'url';
import { ClientOptions, LibrariesIOHeaders, LibrariesIOResult, RequestOptions } from './interfaces/';
export declare type HttpMethod = 'delete' | 'get' | 'post' | 'put';
export declare class RequestService {
    private apiUrl;
    private apiKey;
    constructor(options: ClientOptions);
    delete<T>(endpoint: string, parameters?: RequestOptions): Promise<LibrariesIOHeaders>;
    get<T>(endpoint: string, parameters?: RequestOptions): Promise<LibrariesIOResult<T>>;
    post<T>(endpoint: string, parameters?: RequestOptions): Promise<LibrariesIOResult<T>>;
    put<T>(endpoint: string, parameters?: RequestOptions): Promise<LibrariesIOResult<T>>;
    setApiUrl(apiUrl: URL): void;
    private static mapParameters;
    private request;
}
