"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = require("axios");
var url_1 = require("url");
var APIException_1 = require("./APIException");
var RequestService = /** @class */ (function () {
    function RequestService(options) {
        this.apiUrl = new url_1.URL('/api', 'https://libraries.io');
        if (options.apiUrl) {
            this.setApiUrl(options.apiUrl);
        }
        this.apiKey = options.apiKey;
    }
    RequestService.prototype.delete = function (endpoint, parameters) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, rateLimit, rateLimitRemaining;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.request('delete', endpoint, parameters)];
                    case 1:
                        _a = _b.sent(), rateLimit = _a.rateLimit, rateLimitRemaining = _a.rateLimitRemaining;
                        return [2 /*return*/, { rateLimit: rateLimit, rateLimitRemaining: rateLimitRemaining }];
                }
            });
        });
    };
    RequestService.prototype.get = function (endpoint, parameters) {
        return this.request('get', endpoint, parameters);
    };
    RequestService.prototype.post = function (endpoint, parameters) {
        return this.request('post', endpoint, parameters);
    };
    RequestService.prototype.put = function (endpoint, parameters) {
        return this.request('put', endpoint, parameters);
    };
    RequestService.prototype.setApiUrl = function (apiUrl) {
        this.apiUrl = apiUrl;
    };
    RequestService.mapParameters = function (requestParameters) {
        var map = {
            apiKey: 'api_key',
            includePreRelease: 'include_prerelease',
            perPage: 'per_page',
            sortBy: 'sort',
            query: 'q',
        };
        var mappedParameters = {};
        if (requestParameters) {
            for (var parameterKey in requestParameters) {
                var parameterValue = requestParameters[parameterKey];
                if (parameterValue) {
                    var mappedOption = parameterKey in map ? map[parameterKey] : parameterKey;
                    if (typeof parameterValue === 'object' && Object.values(parameterValue).some(function (val) { return val instanceof Array; })) {
                        for (var filterKey in parameterValue) {
                            var filterValue = parameterValue[filterKey];
                            if (filterValue) {
                                mappedParameters[filterKey] = filterValue.join(',');
                            }
                        }
                    }
                    else if (parameterValue instanceof Array) {
                        parameterValue = parameterValue.join(',');
                    }
                    else {
                        mappedParameters[mappedOption] = parameterValue;
                    }
                }
            }
        }
        return mappedParameters;
    };
    RequestService.prototype.request = function (method, endpoint, parameters) {
        return __awaiter(this, void 0, void 0, function () {
            var params, config, _a, data, headers, status, contentType, rateLimit, rateLimitRemaining, totalResults, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        params = RequestService.mapParameters(__assign({}, parameters, { apiKey: this.apiKey }));
                        config = {
                            method: method,
                            params: params,
                            url: new url_1.URL(this.apiUrl.pathname + endpoint, this.apiUrl).href,
                        };
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.request(config)];
                    case 2:
                        _a = _b.sent(), data = _a.data, headers = _a.headers, status = _a.status;
                        contentType = headers['content-type'] ? String(headers['content-type']) : undefined;
                        rateLimit = Number(headers['x-ratelimit-limit']);
                        rateLimitRemaining = Number(headers['x-ratelimit-remaining']);
                        totalResults = headers['total'] ? Number(headers['total']) : undefined;
                        if (contentType) {
                            if (contentType.includes('application/json')) {
                                return [2 /*return*/, { data: data, rateLimit: rateLimit, rateLimitRemaining: rateLimitRemaining, totalResults: totalResults }];
                            }
                            else {
                                throw new APIException_1.InvalidResponseError('The server responded with invalid data: No JSON sent.');
                            }
                        }
                        else if (status === 204) {
                            return [2 /*return*/, { data: data, rateLimit: rateLimit, rateLimitRemaining: rateLimitRemaining }];
                        }
                        else {
                            throw new APIException_1.InvalidResponseError('The server responded with invalid data: No Content-Type set.');
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _b.sent();
                        throw APIException_1.ExceptionMapper(error_1);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return RequestService;
}());
exports.RequestService = RequestService;
//# sourceMappingURL=RequestService.js.map