import { RequestService } from '../RequestService';
import { LibrariesIOResult, Platform, PaginationOptions } from '../interfaces/';
export declare class PlatformAPI {
    private readonly requestService;
    constructor(requestService: RequestService);
    /**
     * Get list of supported package managers.
     * @see https://libraries.io/api#platforms
     * @param options Pagination options
     */
    getPlatforms(options?: PaginationOptions): Promise<LibrariesIOResult<Platform[]>>;
}
